#include "TCS230.h"

TCS230::TCS230(uint8_t _s0, uint8_t _s1, uint8_t _ s2, uint8_t _s3, uint8_t _out) {
    s0 = _s0;
    s1 = _s1;
    s2 = _s2;
    s3 = _s3;
    out = _out;
}

void TCS230::begin() {
    pinMode(s0, OUTPUT);
    pinMode(s1, OUTPUT);
    pinMode(s2, OUTPUT);
    pinMode(s3, OUTPUT);
    pinMode(out, INPUT);

    digitalWrite(s0, HIGH);
    digitalWrite(s1, LOW);
}

uint8_t TCS230::getRGB(uint8_t mod) {
    switch(mod) {
    case COLOR_R:
        digitalWrite(s2, LOW);
        digitalWrite(s3, LOW);
        return map(pulseIn(out, LOW), 25, 72, 255, 0);
    case COLOR_G:
        digitalWrite(s2, HIGH);
        digitalWrite(s3, HIGH);
        return map(pulseIn(out, LOW), 30, 90, 255, 0);
    case COLOR_B:
        digitalWrite(s2, HIGH);
        digitalWrite(s3, HIGH);
        return map(pulseIn(out, LOW), 25, 70, 255, 0);
    }
}